// ROUTES FOR OUR API
// =============================================================================
var express = require('express');
 var bcrypt = require('bcryptjs');
var router = express.Router();              // get an instance of the express Router
const querystring = require('querystring');
var mysql = require('./mysql');
// const _mysqlLabor = ["123.58.32.151", "pbl"]; //edu數據庫信息
const _mysqlLabor = ["172.16.12.5", "pbl"]; //edu數據庫信息

//統壹處理區域
router.use(async function (req, res, next) {
    await asynnext(req, res, next);
    //// make sure we go to the next routes and don't stop here
    //res.end("");
});

/**
 * @des 參數解釋同上
 */
function asynnext(req, res, next) {
    //異步處理
    return new Promise(async (resolve, reject) => {
        next();
        //resolve(true);aa
    });
}
/*測試*/ 
router.route('/a').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "a", json['ph'], json['pa']);
});
router.route('/b').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "b", json['ph'], json['pa']);
});
/* 注册接口 */
router.route('/register').post(function (req, res, next) {
    //mode的处理
    if (req.body[0]) {
        // 0 用户名 1 用户密码 2用户身份 3 第三方id（可有可无）
        p = Object.values(req.body[0]); //获取用户密码
        //没有第三方id的处理
        // if (p.length < 4) {
        //     p.push("")
        // }
        p[1] = bcrypt.hashSync(p[1], bcrypt.genSaltSync(10));
        //密码加密
        // bcrypt.hash(p[1], 10, function (err, hash) {
        //     if (err) {
        //         return next(err);
        //     }
        //     p[1] = hash;
        // });
        //参数拼接，注册
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "register");
        //返回注册用户数据
        // mysql.usselect(p, function (ret) {
        //     res.end(ret);
        // });
        mysql.usselect(p, function (ret) {
            res.end(JSON.stringify(ret));
        });
    }
});
/*登录接口*/
router.route('/login').all((req, res, next) => {
    //mode的处理
    if (req.body[0]) {
        // 0 用户名 1 用户密码
        c = Object.values(req.body[0]); //获取用户密码
        p = [c[0]]
        // p[1] = bcrypt.hashSync(p[1], bcrypt.genSaltSync(10));
        var _password = [c[0]];
        _password.unshift(_mysqlLabor[0], _mysqlLabor[1], "selectPassword");

        mysql.usselect(_password, function (ret) {
            var _ret = ret
            var paJ = _ret[0][0].userpassword
            bcrypt.compare(c[1], paJ, function (err, result) {
                // console.log(result)
                if (result) {
                    //参数拼接，登录
                    p.unshift(_mysqlLabor[0], _mysqlLabor[1], "selectLogin");
                    //执行存储过程
                    mysql.usselect(p, function (ret) {
                        res.end(JSON.stringify({ status: "1", ...ret }));
                    });
                } else {
                    res.end(JSON.stringify([{ status: "0" }]));
                }
            })
        });

        // console.log(isEqual)
    }

});
/* 找寻重复手机号 */
router.route('/findPhone').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "findPhone", json['un']);
});
/* 新增班级 */
router.route('/insertClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "insertClass", json['name'], json['oid'], json['uid']);
});
/* 查询班级 */
router.route('/selectClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectClass", json['cu'], json['cn'],json['page'],10);
});
/* 删除班级 */
router.route('/deleteClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteClass", json['id']);
});
/* 查询学校 */
router.route('/selectOrg').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectOrg");
});

/* 新增学生 */
router.route('/insertStudent').all((req, res, next) => {
    var json = queryString(req.url);
    json['userpassword'] = bcrypt.hashSync(json['userpassword'], bcrypt.genSaltSync(10))
    getmysql(req, res, "insertStudent",json['ph'],json['username'],json['userpassword'],json['type'],json['oid'],json['tid'],json['cid']);
});

/* 新增学生 */
router.route('/iStudent').all((req, res, next) => {
    postmysql(req, res, "insertStudent");
});

/* 查询学生 */
router.route('/selectStudent').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudent",json['uid'],json['cu'], json['cn'],json['page'],10);
});

/* 查询班级是否有重复 */
router.route('/selectC').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectC",json['className']);
});

/* 查询学校是否有重复 */
router.route('/selectS').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectS",json['schoolName']);
});

/* 修改个人信息 */
router.route('/updateUser').all((req, res, next) => {
    postmysql(req, res, "updateUser");
});

//查询老师的信息
router.route('/getUser').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectUserDeail", json['uid']);
});

//查询教师端消息
router.route('/getNewsTeacher').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectNew", json['uid'], json['page'], 10);
});

//查询通知详情
router.route('/selectNewDetail').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectNewDetail", json['nid']);
});

//查出分组分类
router.route('/getGroup').all((req, res, next) => {
    getmysql(req, res, "selectGroupTeacher");
});

//查询这个老师底下的学生提交的作业
router.route('/getWorks').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWorks", json['bid'], json['isRate'], json['classx'],json['cid'],json['page'],10);
});

//查询项目
router.route('/getProject').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectProject", json['cu'], json['cn'],json['page'],10);
});

//查询项目成员
router.route('/selectProjectStudent').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_student", json['cn'],json['oid'], json['uid']);
});

//新增课程
router.route('/addWork').all((req, res, next) => {
    postmysql(req, res, "insert_teacher_work");
});

//查询课程
router.route('/selectCourse').all((req, res, next) => {
    getmysql(req, res, "select_course");
});

//查询学校
// router.route('/selectSchoolName').all((req, res, next) => {
//     var json = queryString(req.url);
//     getmysql(req, res, "selectOidName",json['oid']);
// });

//删除学生
router.route('/deleteStudent').all((req, res, next) => {
    postmysql(req, res, "delete_student");
});

queryString = function (url) {
    var a = url.split("?");
    var json = querystring.parse(a[1])
    return json;
}

//post存儲過程處理
postmysql = function (req, res, functionname) {
    //mode的處理
    if (req.body[0]) {
        p = Object.values(req.body[0]);
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
        //執行存儲過程
        mysql.usselect(p, function (ret) { res.end(JSON.stringify(ret)); });
    }
}

//get獲取數據庫信息
getmysql = function (req, res, functionname, ...p) {
    p = p || [];
    p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
    //執行存儲過程
    mysql.usselect(p, function (ret) { res.end(JSON.stringify(ret)); });  //
}


module.exports = router;

